#ifndef _SPD_PARAMETERS_H_
#define _SPD_PARAMETERS_H_

#include <utils.hpp>

#include <string>
#include <limits>
using namespace std;

#define OUTFILE_EXT "avi"

#define MAX_CYCLES 2000
#define MAX_CYCLES_DEFAULT 200
#define NFRAMES_DEFAULT std::numeric_limits<int>::max()
#define MAX_WINDOW_SIZE (39*2+1)
#define ALFA_DEFAULT 1.3f
#define BETA_DEFAULT 5.0f

#define SPNOISE 1
#define GAUSSNOISE 2

/*!
 * \struct arguments
 *
 * \brief command line arguments
 */
typedef struct arguments {
  float alfa, beta;
  int w_max, max_cycles, noise, nframes, noise_type, n_processors;
  bool fixed_cycles;
  string fname, out_fname;
  bool verbose, show_enabled, user_out_fname, add_noise;
} arguments;

void print_help();
void get_arguments(char *argv[], int argc, arguments &args);
#endif
