#!/bin/bash

if [ "$#" -lt 3 ]
then
    echo -e " Error: Please, enter correct arguments as follows:\n $0 <repetitions> <workers_limit> <noise(%)> ";
    exit 1;
fi

LOG_DIR="log";
LOG="run.log";
mkdir -p $LOG_DIR;

declare -a app=("spar-denoiser" "spar-denoiser-ond-blk" "spar-denoiser-ord-vector" "spar-denoiser-ord-vector-ond-blk" "spar-tbb-denoiser" "tbb-denoiser" "ff-denoiser");
#declare -a app=("spar-denoiser-ord-pqueue" "spar-denoiser-ord-pqueue-ond" "spar-denoiser-ord-pqueue-blk" "spar-denoiser-ord-pqueue-ond-blk" "tbb-denoiser-ord-pqueue" "tbb-denoiser-ord" "ff-denoiser-ord-pqueue" "ff-denoiser-ord");

#declare -a app=("spar-denoiser-ord-vector");


#declare -a app=("spar-denoiser" "spar-denoiser-ord" "spar-denoiser-ord-ond" "spar-denoiser-ord-blk" "spar-denoiser-ord-ond-blk" "tbb-denoiser" "ff-denoiser");
#declare -a app=("spar-denoiser" "spar-denoiser-ord" "spar-denoiser-ord-ond" "spar-denoiser-ord-blk" "spar-denoiser-ord-ond-blk" "tbb-denoiser" "ff-denoiser");


app_len=${#app[@]};

echo `date` >> $LOG_DIR/$LOG;
echo -e "This is the "$0" log file\n" >> $LOG_DIR/$LOG;
echo `date +%T` >> $LOG_DIR/$LOG;

#interate repetition
for((e=0;e<$1;e++)) do
        #interate number of workers
        for((w=$2; w>0; w--)) do
                #interating app
                for((a=0;a<${app_len};a++)) do
                	./${app[$a]} -N1 -n$3 -p$w /test/test.avi  &>> $LOG_DIR/${app[$a]}$w".log";
                done;
        done;
        #execute the sequential
        ./denoiser -N1 -n$3 ../test/test.avi &>> $LOG_DIR/"denoiser-serial.log";
done;

cd log 

rename 's/spar-denoiser/denoiser-spar/' *.log
#rename 's/tbb-denoiser/denoiser-tbb/' *.log
#rename 's/ff-denoiser/denoiser-ff/' *.log

#sed s/old/new/ file

